Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.53/js/components/PageRenderer/SuccessVariant.es", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', '@frontend-taglib-clay$clayui/layout', 'frontend-js-react-web', 'frontend-js-react-web$react', '../../actions/eventTypes.es', '../../hooks/useForm.es', '../../hooks/usePage.es', '../../util/i18n.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.Page = exports.Container = void 0;

    var _button = require("@frontend-taglib-clay$clayui/button");

    var _dropDown = require("@frontend-taglib-clay$clayui/drop-down");

    var _layout = _interopRequireDefault(require("@frontend-taglib-clay$clayui/layout"));

    var _frontendJsReactWeb = require("frontend-js-react-web");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _eventTypes = require("../../actions/eventTypes.es");

    var _useForm = require("../../hooks/useForm.es");

    var _usePage3 = require("../../hooks/usePage.es");

    var _i18n = require("../../util/i18n.es");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var Container = function Container(_ref) {
      var _strings$successPage;

      var children = _ref.children,
          pages = _ref.pages,
          _ref$strings = _ref.strings,
          strings = _ref$strings === void 0 ? {} : _ref$strings;

      var _usePage = (0, _usePage3.usePage)(),
          editingLanguageId = _usePage.editingLanguageId;

      var dispatch = (0, _useForm.useForm)();
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "page"
        }, /*#__PURE__*/_react.default.createElement(_layout.default.Sheet, {
          className: "ddm-page-success-layout simple-page"
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "form-builder-layout"
        }, /*#__PURE__*/_react.default.createElement("h5", {
          className: "pagination"
        }, (_strings$successPage = strings['success-page']) !== null && _strings$successPage !== void 0 ? _strings$successPage : Liferay.Language.get('success-page')), children)), /*#__PURE__*/_react.default.createElement("div", {
          className: "ddm-paginated-builder-dropdown"
        }, /*#__PURE__*/_react.default.createElement(_dropDown.ClayDropDownWithItems, {
          className: "dropdown-action",
          items: [{
            label: Liferay.Language.get('remove-success-page'),
            onClick: function onClick() {
              dispatch({
                payload: {
                  body: _defineProperty({}, editingLanguageId, ''),
                  enabled: false,
                  title: _defineProperty({}, editingLanguageId, '')
                },
                type: _eventTypes.EVENT_TYPES.SUCCESS_CHANGED
              });
              dispatch({
                payload: pages.length - 1,
                type: _eventTypes.EVENT_TYPES.CHANGE_ACTIVE_PAGE
              });
            }
          }],
          trigger: /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
            displayType: "unstyled",
            symbol: "ellipsis-v",
            title: Liferay.Language.get('page-options')
          })
        })))
      );
    };

    exports.Container = Container;

    var Page = function Page(_ref2) {
      var page = _ref2.page;

      var _usePage2 = (0, _usePage3.usePage)(),
          editingLanguageId = _usePage2.editingLanguageId;

      var dispatch = (0, _useForm.useForm)();
      var defaultLanguageId = page.defaultLanguageId,
          successPageSettings = page.successPageSettings;
      var prevEditingLanguageId = (0, _frontendJsReactWeb.usePrevious)(editingLanguageId);
      var _initialBody$initialT = {
        initialBody: successPageSettings.body && (successPageSettings.body[editingLanguageId] || successPageSettings.body[defaultLanguageId]) || '',
        initialTitle: successPageSettings.title && (successPageSettings.title[editingLanguageId] || successPageSettings.title[defaultLanguageId]) || ''
      },
          initialBody = _initialBody$initialT.initialBody,
          initialTitle = _initialBody$initialT.initialTitle;

      var _useState = (0, _react.useState)(initialBody),
          _useState2 = _slicedToArray(_useState, 2),
          body = _useState2[0],
          setBody = _useState2[1];

      var _useState3 = (0, _react.useState)(initialTitle),
          _useState4 = _slicedToArray(_useState3, 2),
          title = _useState4[0],
          setTitle = _useState4[1];

      (0, _react.useEffect)(function () {
        if (prevEditingLanguageId !== editingLanguageId) {
          setBody(initialBody);
          setTitle(initialTitle);
        }
      }, [editingLanguageId, initialBody, initialTitle, prevEditingLanguageId]);

      var _onChange = function onChange(event, setting) {
        dispatch({
          payload: (0, _i18n.setValue)(successPageSettings, editingLanguageId, setting, event.target.value),
          type: _eventTypes.EVENT_TYPES.SUCCESS_CHANGED
        });
      };

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "active ddm-form-page form-builder-success-page lfr-ddm-form-page"
        }, /*#__PURE__*/_react.default.createElement("input", {
          className: "form-builder-page-header-title form-control p-0",
          maxLength: "120",
          onChange: function onChange(event) {
            setTitle(event.target.value);

            _onChange(event, 'title');
          },
          type: "text",
          value: title
        }), /*#__PURE__*/_react.default.createElement("input", {
          className: "form-builder-page-header-description form-control p-0",
          maxLength: "120",
          onChange: function onChange(event) {
            setBody(event.target.value);

            _onChange(event, 'body');
          },
          type: "text",
          value: body
        }))
      );
    };

    exports.Page = Page;
    //# sourceMappingURL=SuccessVariant.es.js.map
  }
});
//# sourceMappingURL=SuccessVariant.es.js.map