Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.53/js/hooks/useDrop.es", ['module', 'exports', 'require', 'frontend-js-react-web$react-dnd', '../actions/eventTypes.es', '../hooks/useForm.es', './usePage.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.useDrop = exports.DND_ORIGIN_TYPE = void 0;

    var _reactDnd = require("frontend-js-react-web$react-dnd");

    var _eventTypes = require("../actions/eventTypes.es");

    var _useForm = require("../hooks/useForm.es");

    var _usePage2 = require("./usePage.es");

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var defaultSpec = {
      accept: []
    };
    var DND_ORIGIN_TYPE = {
      EMPTY: 'empty',
      FIELD: 'field'
    };
    exports.DND_ORIGIN_TYPE = DND_ORIGIN_TYPE;

    var useDrop = function useDrop(sourceItem) {
      var _usePage = (0, _usePage2.usePage)(),
          dnd = _usePage.dnd;

      var dispatch = (0, _useForm.useForm)();
      var spec = dnd !== null && dnd !== void 0 ? dnd : defaultSpec;

      var _useDndDrop = (0, _reactDnd.useDrop)(_objectSpread(_objectSpread({}, spec), {}, {
        collect: function collect(monitor) {
          return {
            canDrop: monitor.canDrop(),
            overTarget: monitor.isOver()
          };
        },
        drop: function drop(item, monitor) {
          return dispatch({
            payload: {
              item: item,
              monitor: monitor,
              sourceItem: sourceItem
            },
            type: _eventTypes.EVENT_TYPES.FIELD_DROP
          });
        }
      })),
          _useDndDrop2 = _slicedToArray(_useDndDrop, 2),
          _useDndDrop2$ = _useDndDrop2[0],
          canDrop = _useDndDrop2$.canDrop,
          overTarget = _useDndDrop2$.overTarget,
          drop = _useDndDrop2[1];

      return {
        canDrop: canDrop,
        drop: drop,
        overTarget: overTarget
      };
    };

    exports.useDrop = useDrop;
    //# sourceMappingURL=useDrop.es.js.map
  }
});
//# sourceMappingURL=useDrop.es.js.map