Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/components/ManageAllowedFragmentModal", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/modal', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../config/index', '../store/index', '../thunks/updateItemConfig', './AllowedFragmentSelector'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _modal = _interopRequireDefault(require("@frontend-taglib-clay$clayui/modal"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _index = require("../config/index");

    var _index2 = require("../store/index");

    var _updateItemConfig = _interopRequireDefault(require("../thunks/updateItemConfig"));

    var _AllowedFragmentSelector = _interopRequireDefault(require("./AllowedFragmentSelector"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance");
    }

    function _iterableToArray(iter) {
      if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) {
        for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
          arr2[i] = arr[i];
        }return arr2;
      }
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var ManageAllowedFragmentModal = function ManageAllowedFragmentModal(_ref) {
      var item = _ref.item,
          observer = _ref.observer,
          onClose = _ref.onClose;
      var dispatch = (0, _index2.useDispatch)();

      var _useState = (0, _react.useState)(true),
          _useState2 = _slicedToArray(_useState, 2),
          allowNewFragmentEntries = _useState2[0],
          setAllowNewFragmentEntries = _useState2[1];

      var _useState3 = (0, _react.useState)(new Set([])),
          _useState4 = _slicedToArray(_useState3, 2),
          selectedFragments = _useState4[0],
          setSelectedFragments = _useState4[1];

      var _useState5 = (0, _react.useState)(),
          _useState6 = _slicedToArray(_useState5, 2),
          loading = _useState6[0],
          setLoading = _useState6[1];

      var onSelectedFragment = (0, _react.useCallback)(function (_ref2) {
        var allowNewFragmentEntries = _ref2.allowNewFragmentEntries,
            selectedFragments = _ref2.selectedFragments;
        setAllowNewFragmentEntries(allowNewFragmentEntries);
        setSelectedFragments(selectedFragments);
      }, []);
      return (/*#__PURE__*/_react.default.createElement(_modal.default, {
          className: "page-editor__allowed-fragment__modal",
          observer: observer,
          size: "md"
        }, /*#__PURE__*/_react.default.createElement(_modal.default.Header, null, Liferay.Language.get('allowed-fragments')), /*#__PURE__*/_react.default.createElement(_modal.default.Body, null, /*#__PURE__*/_react.default.createElement("p", {
          className: "m-4 small text-secondary"
        }, Liferay.Language.get('specify-which-fragments-a-page-author-is-allowed-to-use-within-the-drop-zone-when-creating-a-page-from-this-master')), /*#__PURE__*/_react.default.createElement(_AllowedFragmentSelector.default, {
          dropZoneConfig: item.config,
          onSelectedFragment: onSelectedFragment
        })), /*#__PURE__*/_react.default.createElement(_modal.default.Footer, {
          last: /*#__PURE__*/_react.default.createElement(_button.default.Group, {
            spaced: true
          }, /*#__PURE__*/_react.default.createElement(_button.default, {
            displayType: "secondary",
            onClick: onClose
          }, Liferay.Language.get('cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
            displayType: "primary",
            onClick: function handleSaveClick() {
              setLoading(true);
              dispatch((0, _updateItemConfig.default)({
                itemConfig: {
                  allowNewFragmentEntries: allowNewFragmentEntries,
                  fragmentEntryKeys: _toConsumableArray(selectedFragments)
                },
                itemId: item.itemId,
                segmentsExperienceId: _index.config.defaultSegmentsExperienceId
              })).then(function () {
                setLoading(false);
                onClose();
              });
            }
          }, loading && /*#__PURE__*/_react.default.createElement("span", {
            className: "inline-item inline-item-before"
          }, /*#__PURE__*/_react.default.createElement("span", {
            "aria-hidden": "true",
            className: "loading-animation"
          })), Liferay.Language.get('save')))
        }))
      );
    };

    var _default = ManageAllowedFragmentModal;
    exports.default = _default;
    //# sourceMappingURL=ManageAllowedFragmentModal.js.map
  }
});
//# sourceMappingURL=ManageAllowedFragmentModal.js.map