Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/thunks/duplicateItem", ['module', 'exports', 'require', '../actions/duplicateItem', '../services/FragmentService'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = duplicateItem;

    var _duplicateItem = _interopRequireDefault(require("../actions/duplicateItem"));

    var _FragmentService = _interopRequireDefault(require("../services/FragmentService"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function duplicateItem(_ref) {
      var itemId = _ref.itemId,
          segmentsExperienceId = _ref.segmentsExperienceId,
          _ref$selectItem = _ref.selectItem,
          selectItem = _ref$selectItem === void 0 ? function () {} : _ref$selectItem;
      return function (dispatch) {
        _FragmentService.default.duplicateItem({
          itemId: itemId,
          onNetworkStatus: dispatch,
          segmentsExperienceId: segmentsExperienceId
        }).then(function (_ref2) {
          var duplicatedFragmentEntryLinks = _ref2.duplicatedFragmentEntryLinks,
              duplicatedItemId = _ref2.duplicatedItemId,
              layoutData = _ref2.layoutData;
          dispatch((0, _duplicateItem.default)({
            addedFragmentEntryLinks: duplicatedFragmentEntryLinks,
            itemId: duplicatedItemId,
            layoutData: layoutData
          }));

          if (duplicatedItemId) {
            selectItem(duplicatedItemId);
          }
        });
      };
    }
    //# sourceMappingURL=duplicateItem.js.map
  }
});
//# sourceMappingURL=duplicateItem.js.map