Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/thunks/resizeColumns", ['module', 'exports', 'require', '../actions/updateColSize', '../services/LayoutService'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = resizeColumns;

    var _updateColSize = _interopRequireDefault(require("../actions/updateColSize"));

    var _LayoutService = _interopRequireDefault(require("../services/LayoutService"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function resizeColumns(_ref) {
      var layoutData = _ref.layoutData,
          rowItemId = _ref.rowItemId,
          segmentsExperienceId = _ref.segmentsExperienceId;
      return function (dispatch) {
        return _LayoutService.default.updateLayoutData({
          layoutData: layoutData,
          onNetworkStatus: dispatch,
          segmentsExperienceId: segmentsExperienceId
        }).then(function () {
          dispatch((0, _updateColSize.default)({
            layoutData: layoutData,
            rowItemId: rowItemId
          }));
        });
      };
    }
    //# sourceMappingURL=resizeColumns.js.map
  }
});
//# sourceMappingURL=resizeColumns.js.map