Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/plugins/experience/reducers/updateExperience", ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function updateExperienceReducer(state, payload) {
      var nextState = state;
      var updatedExperience = payload;
      var experience = state.availableSegmentsExperiences[updatedExperience.segmentsExperienceId];

      if (experience) {
        nextState = _objectSpread(_objectSpread({}, nextState), {}, {
          availableSegmentsExperiences: _objectSpread(_objectSpread({}, nextState.availableSegmentsExperiences), {}, _defineProperty({}, experience.segmentsExperienceId, _objectSpread(_objectSpread({}, updatedExperience), {}, {
            priority: experience.priority
          })))
        });
      }

      return nextState;
    }

    var _default = updateExperienceReducer;
    exports.default = _default;
    //# sourceMappingURL=updateExperience.js.map
  }
});
//# sourceMappingURL=updateExperience.js.map