Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/frontend_tokens/ColorFrontendToken", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/color-picker', '@frontend-taglib-clay$clayui/form', 'frontend-js-web', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../useId'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = ColorFrontendToken;

    var _colorPicker = _interopRequireDefault(require("@frontend-taglib-clay$clayui/color-picker"));

    var _form = _interopRequireWildcard(require("@frontend-taglib-clay$clayui/form"));

    var _frontendJsWeb = require("frontend-js-web");

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _useId = require("../useId");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var debouncedOnValueSelect = (0, _frontendJsWeb.debounce)(function (onValueSelect, value) {
      return onValueSelect(value);
    }, 300);

    function ColorFrontendToken(_ref) {
      var _color$replace;

      var frontendToken = _ref.frontendToken,
          onValueSelect = _ref.onValueSelect,
          value = _ref.value;
      var label = frontendToken.label;

      var _useState = (0, _react.useState)([]),
          _useState2 = _slicedToArray(_useState, 2),
          customColors = _useState2[0],
          setCustomColors = _useState2[1];

      var _useState3 = (0, _react.useState)(value || ''),
          _useState4 = _slicedToArray(_useState3, 2),
          color = _useState4[0],
          setColor = _useState4[1];

      var ref = (0, _react.useRef)(null);
      var id = (0, _useId.useId)();
      (0, _react.useEffect)(function () {
        if (ref.current) {
          ref.current.style.setProperty('--style-book-color-picker-color', color);
        }
      }, [color]);
      return (/*#__PURE__*/_react.default.createElement(_form.default.Group, {
          className: "style-book-editor__color-frontend-token",
          ref: ref,
          small: true
        }, /*#__PURE__*/_react.default.createElement("label", {
          htmlFor: id
        }, label), /*#__PURE__*/_react.default.createElement(_form.ClayInput.Group, {
          small: true
        }, /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, {
          prepend: true,
          shrink: true
        }, /*#__PURE__*/_react.default.createElement(_colorPicker.default, {
          colors: customColors,
          onColorsChange: setCustomColors,
          onValueChange: function onValueChange(color) {
            setColor("#".concat(color));
            debouncedOnValueSelect(onValueSelect, "#".concat(color));
          },
          showHex: false,
          showPalette: false,
          value: (_color$replace = color === null || color === void 0 ? void 0 : color.replace('#', '')) !== null && _color$replace !== void 0 ? _color$replace : ''
        })), /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, {
          append: true
        }, /*#__PURE__*/_react.default.createElement(_form.ClayInput, {
          id: id,
          onChange: function onChange(event) {
            setColor(event.target.value);
            debouncedOnValueSelect(onValueSelect, event.target.value);
          },
          value: color
        }))))
      );
    }
    //# sourceMappingURL=ColorFrontendToken.js.map
  }
});
//# sourceMappingURL=ColorFrontendToken.js.map