Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/useId", ['module', 'exports', 'require', 'frontend-js-react-web$react', './config'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.useId = void 0;

    var _react = require("frontend-js-react-web$react");

    var _config = require("./config");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var nextId = 0;

    var useId = function useId() {
      return (0, _react.useMemo)(function () {
        return "".concat(_config.config.namespace, "_useId_").concat(nextId++);
      }, []);
    };

    exports.useId = useId;
    //# sourceMappingURL=useId.js.map
  }
});
//# sourceMappingURL=useId.js.map