<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<liferay-util:buffer
	var="linkTemplate"
>
	<button class="{cssClass} btn btn-unstyled" data-label="{label}" data-url="{url}" id="{id}" title="{title}">
		{label}
	</button>
</liferay-util:buffer>

<%
Group group = StagingUtil.getStagingGroup(themeDisplay.getSiteGroupId());
boolean privateLayout = ParamUtil.getBoolean(request, "privateLayout");
%>

<liferay-layout:layouts-tree
	draggableTree="<%= false %>"
	groupId="<%= group.getGroupId() %>"
	linkTemplate="<%= linkTemplate %>"
	privateLayout="<%= privateLayout %>"
	rootLinkTemplate='<span class="{cssClass}" id="{id}" title="{title}">{label}</span>'
	rootNodeName="<%= group.getLayoutRootNodeName(privateLayout, locale) %>"
	treeId="layoutsTree"
/>