Liferay.Loader.define("journal-article-dynamic-data-mapping-form-field-type@1.0.18/JournalArticleSelector", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/form', 'dynamic-data-mapping-form-field-type', 'frontend-js-web', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _form = _interopRequireWildcard(require("@frontend-taglib-clay$clayui/form"));

    var _dynamicDataMappingFormFieldType = require("dynamic-data-mapping-form-field-type");

    var _frontendJsWeb = require("frontend-js-web");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var JournalArticleSelector = function JournalArticleSelector(_ref) {
      var disabled = _ref.disabled,
          editingLanguageId = _ref.editingLanguageId,
          inputValue = _ref.inputValue,
          itemSelectorURL = _ref.itemSelectorURL,
          name = _ref.name,
          onChange = _ref.onChange,
          portletNamespace = _ref.portletNamespace;

      var _useState = (0, _react.useState)(function () {
        return JSON.parse(inputValue || '{}');
      }),
          _useState2 = _slicedToArray(_useState, 2),
          article = _useState2[0],
          setArticle = _useState2[1];

      (0, _react.useEffect)(function () {
        setArticle(JSON.parse(inputValue || '{}'));
      }, [inputValue]);

      var handleFieldChanged = function handleFieldChanged(event) {
        var selectedItem = event.selectedItem;

        if (selectedItem && selectedItem.value) {
          setArticle(JSON.parse(selectedItem.value));
          onChange(selectedItem.value);
        }
      };

      var handleItemSelectorTriggerClick = function handleItemSelectorTriggerClick(event) {
        event.preventDefault();
        (0, _frontendJsWeb.openSelectionModal)({
          onSelect: handleFieldChanged,
          selectEventName: "".concat(portletNamespace, "selectJournalArticle"),
          title: Liferay.Language.get('journal-article'),
          url: itemSelectorURL
        });
      };

      return (/*#__PURE__*/_react.default.createElement(_form.default.Group, {
          style: {
            marginBottom: '0.5rem'
          }
        }, /*#__PURE__*/_react.default.createElement(_form.ClayInput.Group, null, /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, {
          className: "d-none d-sm-block",
          prepend: true
        }, /*#__PURE__*/_react.default.createElement("input", {
          name: name,
          type: "hidden",
          value: JSON.stringify(article)
        }), /*#__PURE__*/_react.default.createElement(_form.ClayInput, {
          className: "bg-light",
          dir: Liferay.Language.direction[editingLanguageId],
          disabled: disabled,
          lang: editingLanguageId,
          onClick: handleItemSelectorTriggerClick,
          readOnly: true,
          type: "text",
          value: article.title || ''
        })), /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, {
          append: true,
          shrink: true
        }, /*#__PURE__*/_react.default.createElement(_button.default, {
          disabled: disabled,
          displayType: "secondary",
          onClick: handleItemSelectorTriggerClick,
          type: "button"
        }, Liferay.Language.get('select'))), article.classPK && /*#__PURE__*/_react.default.createElement(_form.ClayInput.GroupItem, {
          shrink: true
        }, /*#__PURE__*/_react.default.createElement(_button.default, {
          disabled: disabled,
          displayType: "secondary",
          onClick: function handleClearClick() {
            setArticle({});
            onChange('');
          },
          type: "button"
        }, Liferay.Language.get('clear')))), article.message && /*#__PURE__*/_react.default.createElement("div", {
          className: "form-feedback-item"
        }, article.message))
      );
    };

    var Main = function Main(_ref2) {
      var editingLanguageId = _ref2.editingLanguageId,
          itemSelectorURL = _ref2.itemSelectorURL,
          name = _ref2.name,
          _onChange = _ref2.onChange,
          portletNamespace = _ref2.portletNamespace,
          predefinedValue = _ref2.predefinedValue,
          readOnly = _ref2.readOnly,
          value = _ref2.value,
          otherProps = _objectWithoutProperties(_ref2, ["editingLanguageId", "itemSelectorURL", "name", "onChange", "portletNamespace", "predefinedValue", "readOnly", "value"]);

      return (/*#__PURE__*/_react.default.createElement(_dynamicDataMappingFormFieldType.ReactFieldBase, _extends({}, otherProps, {
          name: name,
          readOnly: readOnly
        }), /*#__PURE__*/_react.default.createElement(JournalArticleSelector, {
          disabled: readOnly,
          editingLanguageId: editingLanguageId,
          inputValue: value && value !== '' ? value : predefinedValue,
          itemSelectorURL: itemSelectorURL,
          name: name,
          onChange: function onChange(value) {
            return _onChange({}, value);
          },
          portletNamespace: portletNamespace
        }))
      );
    };

    Main.displayName = 'JournalArticleSelector';
    var _default = Main;
    exports.default = _default;
    //# sourceMappingURL=JournalArticleSelector.js.map
  }
});
//# sourceMappingURL=JournalArticleSelector.js.map