Liferay.Loader.define("layout-admin-web@4.0.99/js/miller_columns/DragPreview", ['module', 'exports', 'require', 'frontend-js-react-web$react', 'frontend-js-react-web$react-dnd'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = DragPreview;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _reactDnd = require("frontend-js-react-web$react-dnd");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var getItemStyles = function getItemStyles(currentOffset, ref, rtl) {
      if (!currentOffset || !ref.current) {
        return {
          display: 'none'
        };
      }

      var rect = ref.current.getBoundingClientRect();
      var x = rtl ? currentOffset.x + rect.width * 0.5 - window.innerWidth : currentOffset.x - rect.width * 0.5;
      var y = currentOffset.y - rect.height * 0.5;
      var transform = "translate(".concat(x, "px, ").concat(y, "px)");
      return {
        WebkitTransform: transform,
        transform: transform
      };
    };

    function DragPreview(_ref) {
      var rtl = _ref.rtl;
      var ref = (0, _react.useRef)();

      var _useDragLayer = (0, _reactDnd.useDragLayer)(function (monitor) {
        var _monitor$getItem;

        return {
          currentOffset: monitor.getClientOffset(),
          isDragging: monitor.isDragging(),
          items: (_monitor$getItem = monitor.getItem()) === null || _monitor$getItem === void 0 ? void 0 : _monitor$getItem.items
        };
      }),
          currentOffset = _useDragLayer.currentOffset,
          isDragging = _useDragLayer.isDragging,
          items = _useDragLayer.items;

      var _useState = (0, _react.useState)(),
          _useState2 = _slicedToArray(_useState, 2),
          label = _useState2[0],
          setLabel = _useState2[1];

      (0, _react.useEffect)(function () {
        if (items) {
          if (items.length > 1) {
            setLabel(Liferay.Util.sub(Liferay.Language.get('x-elements'), items.length));
          } else {
            var _items = _slicedToArray(items, 1),
                item = _items[0];

            setLabel(item.title);
          }
        }
      }, [items]);

      if (!isDragging) {
        return null;
      }

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "miller-columns__drag-preview"
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "miller-columns__drag-preview__content",
          ref: ref,
          style: getItemStyles(currentOffset, ref, rtl)
        }, label))
      );
    }
    //# sourceMappingURL=DragPreview.js.map
  }
});
//# sourceMappingURL=DragPreview.js.map