Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/components/layout-data-items/CollectionItemWithControls", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../CollectionItemContext', '../TopperEmpty'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _CollectionItemContext = require("../CollectionItemContext");

    var _TopperEmpty = _interopRequireDefault(require("../TopperEmpty"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var CollectionItemWithControls = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
      var children = _ref.children,
          item = _ref.item;

      var _useContext = (0, _react.useContext)(_CollectionItemContext.CollectionItemContext),
          collectionItem = _useContext.collectionItem;

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "page-editor__collection__block"
        }, /*#__PURE__*/_react.default.createElement(_TopperEmpty.default, {
          item: item
        }, _react.default.Children.count(children) === 0 ? /*#__PURE__*/_react.default.createElement("div", {
          className: "page-editor__collection-item",
          ref: ref
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "page-editor__collection-item__border"
        }, /*#__PURE__*/_react.default.createElement("p", {
          className: "page-editor__collection-item__title"
        }, collectionItem.title || collectionItem.defaultTitle))) : /*#__PURE__*/_react.default.createElement("div", {
          ref: ref
        }, children)))
      );
    });

    var _default = CollectionItemWithControls;
    exports.default = _default;
    //# sourceMappingURL=CollectionItemWithControls.js.map
  }
});
//# sourceMappingURL=CollectionItemWithControls.js.map