Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/components/layout-data-items/FragmentWithControls", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../../../core/hooks/useSetRef', '../../../prop-types/index', '../Layout', '../Topper', '../fragment-content/FragmentContent', '../fragment-content/FragmentContentInteractionsFilter', '../fragment-content/FragmentContentProcessor'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _useSetRef3 = _interopRequireDefault(require("../../../core/hooks/useSetRef"));

    var _index = require("../../../prop-types/index");

    var _Layout = _interopRequireDefault(require("../Layout"));

    var _Topper = _interopRequireDefault(require("../Topper"));

    var _FragmentContent = _interopRequireDefault(require("../fragment-content/FragmentContent"));

    var _FragmentContentInteractionsFilter = _interopRequireDefault(require("../fragment-content/FragmentContentInteractionsFilter"));

    var _FragmentContentProcessor = _interopRequireDefault(require("../fragment-content/FragmentContentProcessor"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var FragmentWithControls = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
      var item = _ref.item;

      var _useSetRef = (0, _useSetRef3.default)(ref),
          _useSetRef2 = _slicedToArray(_useSetRef, 2),
          setRef = _useSetRef2[0],
          itemElement = _useSetRef2[1];

      var getPortals = (0, _react.useCallback)(function (element) {
        return Array.from(element.querySelectorAll('lfr-drop-zone')).map(function (dropZoneElement) {
          var mainItemId = dropZoneElement.getAttribute('uuid') || '';

          var Component = function Component() {
            return mainItemId ? /*#__PURE__*/_react.default.createElement(_Layout.default, {
              mainItemId: mainItemId
            }) : null;
          };

          Component.displayName = "DropZone(".concat(mainItemId, ")");
          return {
            Component: Component,
            element: dropZoneElement
          };
        });
      }, []);
      return (/*#__PURE__*/_react.default.createElement(_Topper.default, {
          item: item,
          itemElement: itemElement
        }, /*#__PURE__*/_react.default.createElement(_FragmentContentInteractionsFilter.default, {
          fragmentEntryLinkId: item.config.fragmentEntryLinkId,
          itemId: item.itemId
        }, /*#__PURE__*/_react.default.createElement(_FragmentContent.default, {
          elementRef: setRef,
          fragmentEntryLinkId: item.config.fragmentEntryLinkId,
          getPortals: getPortals,
          item: item,
          withinTopper: true
        }), /*#__PURE__*/_react.default.createElement(_FragmentContentProcessor.default, {
          fragmentEntryLinkId: item.config.fragmentEntryLinkId,
          itemId: item.itemId
        })))
      );
    });

    FragmentWithControls.displayName = 'FragmentWithControls';
    var _default = FragmentWithControls;
    exports.default = _default;
    //# sourceMappingURL=FragmentWithControls.js.map
  }
});
//# sourceMappingURL=FragmentWithControls.js.map