Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/thunks/addFragmentComment", ['module', 'exports', 'require', '../actions/addFragmentEntryLinkComment', '../services/FragmentService'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = addFragmentComment;

    var _addFragmentEntryLinkComment = _interopRequireDefault(require("../actions/addFragmentEntryLinkComment"));

    var _FragmentService = _interopRequireDefault(require("../services/FragmentService"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function addFragmentComment(_ref) {
      var body = _ref.body,
          fragmentEntryLinkId = _ref.fragmentEntryLinkId,
          _ref$parentCommentId = _ref.parentCommentId,
          parentCommentId = _ref$parentCommentId === void 0 ? undefined : _ref$parentCommentId;
      return function (dispatch) {
        return _FragmentService.default.addComment({
          body: body,
          fragmentEntryLinkId: fragmentEntryLinkId,
          onNetworkStatus: dispatch,
          parentCommentId: parentCommentId
        }).then(function (fragmentEntryLinkComment) {
          dispatch((0, _addFragmentEntryLinkComment.default)({
            fragmentEntryLinkComment: fragmentEntryLinkComment,
            fragmentEntryLinkId: fragmentEntryLinkId,
            parentCommentId: parentCommentId
          }));
        });
      };
    }
    //# sourceMappingURL=addFragmentComment.js.map
  }
});
//# sourceMappingURL=addFragmentComment.js.map