Liferay.Loader.define("layout-content-page-editor-web@2.0.123/page_editor/app/thunks/editFragmentComment", ['module', 'exports', 'require', '../actions/editFragmentEntryLinkComment', '../services/FragmentService'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = editFragmentComment;

    var _editFragmentEntryLinkComment = _interopRequireDefault(require("../actions/editFragmentEntryLinkComment"));

    var _FragmentService = _interopRequireDefault(require("../services/FragmentService"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function editFragmentComment(_ref) {
      var body = _ref.body,
          commentId = _ref.commentId,
          fragmentEntryLinkId = _ref.fragmentEntryLinkId,
          parentCommentId = _ref.parentCommentId,
          _ref$resolved = _ref.resolved,
          resolved = _ref$resolved === void 0 ? false : _ref$resolved;
      return function (dispatch) {
        return _FragmentService.default.editComment({
          body: body,
          commentId: commentId,
          onNetworkStatus: dispatch,
          resolved: resolved
        }).then(function (fragmentEntryLinkComment) {
          dispatch((0, _editFragmentEntryLinkComment.default)({
            fragmentEntryLinkComment: fragmentEntryLinkComment,
            fragmentEntryLinkId: fragmentEntryLinkId,
            parentCommentId: parentCommentId
          }));
        });
      };
    }
    //# sourceMappingURL=editFragmentComment.js.map
  }
});
//# sourceMappingURL=editFragmentComment.js.map