Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/PreviewInfoBar", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/icon', '@frontend-taglib-clay$clayui/popover', 'frontend-js-metal-web$metal-position', 'frontend-js-react-web$react', './LayoutSelector'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = PreviewInfoBar;

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _popover = _interopRequireDefault(require("@frontend-taglib-clay$clayui/popover"));

    var _metalPosition = require("frontend-js-metal-web$metal-position");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _LayoutSelector = _interopRequireDefault(require("./LayoutSelector"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function PreviewInfoBar() {
      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          isShowPopover = _useState2[0],
          setIsShowPopover = _useState2[1];

      var popoverRef = (0, _react.useRef)(null);
      var helpIconRef = (0, _react.useRef)(null);
      (0, _react.useLayoutEffect)(function () {
        if (isShowPopover) {
          _metalPosition.Align.align(popoverRef.current, helpIconRef.current, _metalPosition.Align.BottomRight, false);
        }
      }, [isShowPopover]);
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "style-book-editor__page-preview-info-bar"
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: "align-items-center d-flex justify-content-center"
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "style-book-editor__page-preview-text"
        }, Liferay.Language.get('page-preview')), /*#__PURE__*/_react.default.createElement(_LayoutSelector.default, null)), /*#__PURE__*/_react.default.createElement("span", {
          className: "d-none d-xl-block"
        }, Liferay.Language.get('edit-the-style-book-using-the-sidebar-form.-you-can-preview-the-changes-instantly')), /*#__PURE__*/_react.default.createElement("span", {
          className: "d-block d-xl-none"
        }, /*#__PURE__*/_react.default.createElement(_icon.default, {
          onMouseEnter: function onMouseEnter() {
            return setIsShowPopover(true);
          },
          onMouseLeave: function onMouseLeave() {
            return setIsShowPopover(false);
          },
          ref: helpIconRef,
          symbol: 'question-circle'
        }), isShowPopover && /*#__PURE__*/_react.default.createElement(_popover.default, {
          alignPosition: 'bottom-right',
          ref: popoverRef
        }, Liferay.Language.get('edit-the-style-book-using-the-sidebar-form.-you-can-preview-the-changes-instantly'))))
      );
    }
    //# sourceMappingURL=PreviewInfoBar.js.map
  }
});
//# sourceMappingURL=PreviewInfoBar.js.map