Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/Sidebar", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', 'frontend-js-react-web$react', './FrontendTokenSet', './Toolbar', './config'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = Sidebar;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _dropDown = _interopRequireWildcard(require("@frontend-taglib-clay$clayui/drop-down"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _FrontendTokenSet = _interopRequireDefault(require("./FrontendTokenSet"));

    var _Toolbar = _interopRequireDefault(require("./Toolbar"));

    var _config = require("./config");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function Sidebar() {
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "style-book-editor__sidebar"
        }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, null), /*#__PURE__*/_react.default.createElement(ThemeInformation, null), _config.config.frontendTokenDefinition.frontendTokenCategories && /*#__PURE__*/_react.default.createElement(SidebarContent, null))
      );
    }

    function ThemeInformation() {
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "pb-0 pt-3 px-3"
        }, /*#__PURE__*/_react.default.createElement("p", {
          className: "small text-secondary"
        }, Liferay.Language.get('this-token-definition-belongs-to-the-theme-set-for-public-pages')), /*#__PURE__*/_react.default.createElement("p", {
          className: "mb-0 small"
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "font-weight-semi-bold"
        }, "".concat(Liferay.Language.get('theme'), ": ")), _config.config.themeName))
      );
    }

    function SidebarContent() {
      var frontendTokenCategories = _config.config.frontendTokenDefinition.frontendTokenCategories;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          active = _useState2[0],
          setActive = _useState2[1];

      var _useState3 = (0, _react.useState)(frontendTokenCategories[0]),
          _useState4 = _slicedToArray(_useState3, 2),
          selectedCategory = _useState4[0],
          setSelectedCategory = _useState4[1];

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "style-book-editor__sidebar-content"
        }, selectedCategory && /*#__PURE__*/_react.default.createElement(_dropDown.default, {
          active: active,
          alignmentPosition: _dropDown.Align.BottomLeft,
          onActiveChange: setActive,
          trigger: /*#__PURE__*/_react.default.createElement(_button.default, {
            className: "form-control form-control-select form-control-sm mb-3 text-left",
            displayType: "secondary",
            small: true,
            type: "button"
          }, selectedCategory.label)
        }, /*#__PURE__*/_react.default.createElement(_dropDown.default.ItemList, null, frontendTokenCategories.map(function (frontendTokenCategory, index) {
          return (/*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
              key: index,
              onClick: function onClick() {
                setSelectedCategory(frontendTokenCategory);
                setActive(false);
              }
            }, frontendTokenCategory.label)
          );
        }))), selectedCategory === null || selectedCategory === void 0 ? void 0 : selectedCategory.frontendTokenSets.map(function (_ref) {
          var frontendTokens = _ref.frontendTokens,
              label = _ref.label,
              name = _ref.name;
          return (/*#__PURE__*/_react.default.createElement(_FrontendTokenSet.default, {
              frontendTokens: frontendTokens,
              key: name,
              label: label,
              name: name
            })
          );
        }))
      );
    }
    //# sourceMappingURL=Sidebar.js.map
  }
});
//# sourceMappingURL=Sidebar.js.map