Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/useCloseProductMenu", ['module', 'exports', 'require', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.useCloseProductMenu = useCloseProductMenu;

    var _react = require("frontend-js-react-web$react");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function useCloseProductMenu() {
      (0, _react.useEffect)(function () {
        var sideNavigation = Liferay.SideNavigation.instance(document.querySelector('.product-menu-toggle'));

        if (sideNavigation && sideNavigation.visible()) {
          sideNavigation.hide();
        }
      }, []);
    }
    //# sourceMappingURL=useCloseProductMenu.js.map
  }
});
//# sourceMappingURL=useCloseProductMenu.js.map